package net.pricefx.common.apibuilder;

import java.math.BigDecimal;

@SuppressWarnings("rawtypes")
public abstract class AbstractOptions<ATTACHEDTO extends ObjectIdentity, T extends AbstractOptions> extends BacklinkBuilder<ATTACHEDTO> {
	
	public AbstractOptions(String instanceId, String classId, ATTACHEDTO parentChartObjectIdentity, IdGenerator idGenerator, Invocations<MethodInvocation> invocations) {
		super(instanceId, classId, parentChartObjectIdentity);
	}

	@SuppressWarnings("unchecked")
	public final T setTitle(String title) {

		addInvocation("setTitle", title);
		return (T) this;
	}

	@SuppressWarnings("unchecked")
	public final T setSubtitle(String subtitle) {

		addInvocation("setSubtitle", subtitle);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setHideLegend(Boolean hideLegend) {

		addInvocation("setHideLegend", hideLegend);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setHideTooltips(Boolean hideTooltips) {

		addInvocation("setHideTooltips", hideTooltips);
		return (T) this;
	}

	@SuppressWarnings("unchecked")
	public final T setComparison(Boolean comparison) {

		addInvocation("setComparison", comparison);
		return (T) this;
	}

	@SuppressWarnings("unchecked")
	public final T setXLabel(String xLabel) {

		addInvocation("setXLabel", xLabel);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setYLabel(String yLabel) {

		addInvocation("setYLabel", yLabel);			
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setMaxDataPoints(BigDecimal maximumNumberOfDataPoints) {

		addInvocation("setMaxDataPoints", maximumNumberOfDataPoints);			
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setYMin(BigDecimal yMin) {

		addInvocation("setYMin", yMin);			
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setYMax(BigDecimal xMax) {

		addInvocation("setYMax", xMax);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setShowZAxis(Boolean showZAxis) {

		addInvocation("setShowZAxis", showZAxis);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setZLabel(String zLabel) {

		addInvocation("setZLabel", zLabel);
		return (T) this;
	}
		
	@SuppressWarnings("unchecked")
	public final T setZMin(BigDecimal zMin) {

		addInvocation("setZMin", zMin);
		return (T) this;
	}
	
	@SuppressWarnings("unchecked")
	public final T setZMax(BigDecimal zMax) {

		addInvocation("setZMax", zMax);
		return (T) this;
	}
		
}