package net.pricefx.common.apibuilder.chart;

import net.pricefx.common.api.chart.ChartType;
import net.pricefx.common.apibuilder.MethodInvocation;
import net.pricefx.common.apibuilder.Methods;

public class ChartBuilderResultToHelpFormatProcessor {

	private ChartBuilderResult chartBuilderResult;
	private Methods m;

	public ChartBuilderResultToHelpFormatProcessor(ChartBuilderResult chartBuilderResult) {
		this.chartBuilderResult = chartBuilderResult;
		this.m = new Methods();
	}

	public String process() {
		String helpText = "";
		
		if (ChartType.SCATTER.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newScatter()\n";
		else if (ChartType.TIMESERIES_SCATTER.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newTimeSeriesScatter()\n";
		else if (ChartType.BAR.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newBarLine()\n";
		else if (ChartType.BUBBLE.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newBubble()\n";
		else if (ChartType.PIE.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newPie()\n";
		else if (ChartType.WATERFALL.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newWaterfall()\n";
		else if (ChartType.WATERFALLCOMPARISON.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newWaterfallComparison()\n";
		else if (ChartType.TIMESERIES.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newTimeSeries()\n";
		else if (ChartType.TIMESERIES_DATETIME.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newDetailedTimeSeries()\n";		
		else if (ChartType.HISTOGRAM.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newHistogram()\n";	
		else if (ChartType.BOXPLOT.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newBoxplot()\n";	
		else if (ChartType.HEATMAP.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newHeatmap()\n";	
		else if (ChartType.DATATABLE.equals(chartBuilderResult.additionalInfo))
			helpText = "def chart = api.newChartBuilder()\n\t.newDataTable()\n";		
		else throw new UnsupportedOperationException(chartBuilderResult.additionalInfo + " not supported.");
		
			
		for (MethodInvocation i : chartBuilderResult.invocations) {
			int indentationLevel = i.methodNameId().split("\\.").length;
			for (int j = 0; j < indentationLevel ; j ++) helpText += "\t";
			String methodName = i.methodNameToken().substring(i.methodNameToken().lastIndexOf('.'));
			helpText += m.createMethodName(methodName, i.arguments());
			helpText += "\n";
		}
		
		return helpText;
	}
		
}
