package net.pricefx.formulaengine.optimization;

import net.pricefx.formulaengine.DatamartContext;

import java.util.Map;

/**
 * The {@link ModelCalculationFormulaContext} is exposed to model calculation logics through the <code>model</code> binding.
 * <p>
 * It contains read and write operations, contrary to {@link ModelEvaluationFormulaContext}.
 */
public interface ModelCalculationFormulaContext extends ModelFormulaContextReadWrite {
    final class ForFormulaDeployment implements ModelCalculationFormulaContext {
        @Override
        public String uniqueName() {
            return null;
        }

        @Override
        public String label() {
            return null;
        }

        @Override
        public Map<String, Object> inputs(String stepName, String tabName) {
            return Map.of();
        }

        @Override
        public Map<String, Object> outputs(String stepName, String calculationName) {
            return Map.of();
        }

        @Override
        public DatamartContext.Table table(String name) {
            return null;
        }

        @Override
        public void startJobTriggerCalculation(String imageName, String imageTag, String parameters, String jobName) {
            // noop
        }

        @Override
        public DatamartContext.Table addTable(String name, Map<String, Object> tableSpecs) {
            return null;
        }

        @Override
        public long loadTable(DatamartContext.Table table, DatamartContext.Query source, boolean truncate) {
            return 0;
        }

        @Override
        public long loadTable(DatamartContext.Table table, DatamartContext.SqlQuery source, boolean truncate) {
            return 0;
        }

        @Override
        public void truncateTable(DatamartContext.Table table) {
            // noop
        }

        @Override
        public void dropTable(DatamartContext.Table table) {
            // noop
        }
    }
}
